#ifndef _EIGENVALUE_H_
#define _EIGENVALUE_H_

#include <math.h>

#include "logUtil.h"

#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
#define IMAX(a,b) ((a) > (b) ? (a) : (b))
#define SWAP(g,h) {y=(g);(g)=(h);(h)=y;}
#define RADIX 2.0

extern void GetEigenvalues(double **a, double *real, double *imaginary, int n_var);

#endif /* _EIGENVALUE_H_ */
