/*  DBMathModel.xmlʬ䤹롣
 *	
 *	dividedata -IDBMathModel.xml [-d*]
 *
 *	DBMathModel.xml Ǥ2nd٥Υ
 *	ƥեΥե̾° type="xml" or type="txt" γĥҤȤʤäƤ
 *	ΤǤ꤬˥եʬ䤹
 */
#include <stdio.h>
#include <string.h>

/* 顼ؿ */
#include "logUtil.h"

#define BUFFSIZE 65536

static int read_start( char *tag, char *t_name, char *attribute);
static int read_end( char *tag, char *t_name);

/*----------------main------------------------------------------
 *
 */
int main(int argc, char *argv[])
{
	int i, fcount=0;
	char tline[BUFFSIZE];
	char fname_i[FILENAME_MAX];
	char fname_t[FILENAME_MAX];
	char name_base[FILENAME_MAX];
	char name_base2[FILENAME_MAX];
	char name_suffix[FILENAME_MAX];
	FILE *fp_i, *fp_t;
	
#ifdef DBG
	/* open debug-log file.*/
	if(log_dbginit(argc, argv)) {
		printf("Cannot open dbgLog file!!");
		goto	err;
	}
#endif

	/* open sys-log file.*/
	if(log_sysinit(argc, argv)) {
		printf("Cannot open sysLog file!!");
		goto	err;
	}

	/* ץβ*/
	for (i = 0; i < argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'I':
				fcount++;
				strcpy(fname_i, &argv[i][2]);
				break;
			case 'd':
				break;
			default:
				log_sys("Invalid argument !!\n");
				goto	err;
			}
		}
	}
	if (fcount != 1) {
		log_sys("This program needs 1 input files. But now it has %d file(s).\n", fcount);
		log_sys("\n\tusage : dividedata -Ifilename\n\n");
		goto	err;
	}

	/* ϥե򥪡ץ󤹤 */
	if((fp_i = fopen(fname_i, "r")) == NULL){
		log_sys("Cannot open %s\n", fname_i);
		goto	err;
	}
	fgets(tline, sizeof tline, fp_i);	/* СɤФ */
	fgets(tline, sizeof tline, fp_i);	/* <DBMathModel> ɤФ */
	while(fgets(tline, sizeof tline, fp_i)) {	/* ǡɤ߹ߤΥ롼 */
		if (read_start(tline, name_base, name_suffix)) {	/* 2nd ٥γϥ */
			/* 2nd ٥γϥե̾ϥե򥪡ץ󤹤 */
			sprintf(fname_t, "%s.%s", name_base, name_suffix);
			if((fp_t = fopen(fname_t, "w")) == NULL){
				log_sys("Cannot open %s\n", fname_t);
				goto err;
			} else {
				/* 2nd ٥Υǡɤ߹ߥ롼 */
				while(fgets(tline, sizeof tline, fp_i)) {
					if (read_end(tline, name_base2)) {	/* 2nd ٥νλ */
						if (strcpy(name_base, name_base2)) {
							/* 2nd ٥νλǤХեĤƥ롼פȴ */
							fclose(fp_t);
							break;
						} else {
							log_sys("2nd level end-tag is expected.\n");
							log_sys("\tBut now : %s\n", tline);
							goto err;
						}
					} else {
						if (strncmp(tline, "<!-", 3) && strncmp(tline, "-->", 3)) {
							/* ȹ԰ʳΥǡԤϥե˽񤭽Ф */
							/* ǡԤιƬˤϥ֤ĤƤΤǼƤ */
							fprintf(fp_t, "%s", &tline[1]);
						}
					}
				}
			}
		} else {
			if (read_end(tline, name_base2)) {				/* λ */
				if (strcmp(name_base2, "DBMathModel")==0) {	/* 1st ٥νλ */
					fclose(fp_i);
					log_sys("### Finish successfully!!\n");
					return 0;
				} else {
					log_sys("1st level end-tag is expected.\n");
					log_sys("\tBut now : %s\n", tline);
					goto err;
				}
			}
		}
	}

err:;
	log_sys("### ERROR!!\n");
	return -1;
}

/*---------------------- read_start -------------------------------------------
 *	Ԥɤ߹ 2nd ٥γϥǤФΥ̾(t_name)°(attribute)
 *	֤꥿ͤȤƥ̾Ĺ֤
 */
static int read_start(char *tag, char *t_name, char *attribute)
{
	char *cp, *cpb, *cps;
	int delim_cnt = 0, n_cnt = 0;

	cp = tag;
	if (*cp != '<') return 0;	/* Ƭ < ǻϤޤϤ */
	cpb = t_name;
	cps = attribute;
	for (; *cp; ) {
			/*printf("%s, %s, %s, %d\n", cp, cpb, cps, delim_cnt); */
		if (*cp == '\n' || *cp == '\0' || *cp == '/') {
			break;
		} else if (*cp =='<') {
			cp++;
		} else if (*cp =='"' || *cp == ' ') {	/* ' ', '"' ǥߥȤƥ */
			delim_cnt++;
			cp++;
		} else {
			if (delim_cnt==0) {		/* ڡޤǤ̾ */
				*(cpb++) = *(cp++);
				n_cnt++;
			} else if (delim_cnt==2) {	/* ܤ ɤޤǤ° */
				*(cps++) = *(cp++);
			} else {
				cp++;
			}
		}
	}
	*cpb = *cps = '\0';
	return n_cnt;
}

/*---------------------- read_end -------------------------------------------
 *	Ԥɤ߹ 2nd ٥νλǤФΥ̾(t_name)֤
 *	꥿ͤȤƥ̾Ĺ֤
 */
static int read_end(char *tag, char *t_name)
{
	char *cp, *cpb;
	int n_cnt = 0;

	cp = tag;
	if (*cp != '<') return 0;	/* Ƭ < ǻϤޤϤ */
	cp++;
	if (*cp != '/') return 0;	/*  / ΤϤ */
	cp++;
	cpb = t_name;
	for (; *cp; ) {
			/*printf("%s, %s\n", cp, cpb); */
		if (*cp == '\n' || *cp == '\0' || *cp == '>') {
			break;
		} else {
			*(cpb++) = *(cp++);
			n_cnt++;
		}
	}
	*cpb = '\0';
	return n_cnt;
}
