/*
 * Utility of binary/gray coding
 *
 * utl_encode.h
 */

#ifndef _UTL_ENCODE_H_
#define _UTL_ENCODE_H_

int BinaryEncode(const int *in_array, int array_size, char *bit_array, int b_array_size, int quantumNumber);

int BinaryDecode(const char *bit_array, int b_array_size, int quantumNumber, int out_array_size, int *out_array);

int GrayEncode(const int *in_array, int array_size, char *bit_array, int b_array_size, int quantumNumber);

int GrayDecode(const char *bit_array, int b_array_size, int quantumNumber, int out_array_size, int *out_array);

#endif /* _UTL_ALLOC_H_ */
