/*
 * Utility of text manipulation
 *
 * utl_text.h
 */

#ifndef _UTL_TEXT_H_
#define _UTL_TEXT_H_

/*
 * Macros
 */
#define FIND_NO_DELIM	-1

/* IsCommentLine function's return type */
#define	COMMENT_LINE	1
#define NOT_COMMENT	2


/*
 * Prottype declaration of functions
 */

/*-----
 * DelSpaceTabؿ
 * 	ʸ󤫤顤ȥ֤
 */
extern void DelSpaceTab(char *buf);

/*-----
 * DelCommentؿ
 * 	ʸ󤫤顤Ȥ
 */
extern void DelComment(char *buf);

/*-----
 * FindDelimؿ
 * 	ǥߥ򸫤Ĥindex֤
 */
extern int FindDelim(char *buf, char delim);

/*-----
 * MyStrtokؿ
 * 	ɸ饤֥ؿstrtokεǽ򶯲
 * strtokȤʤ
 * 	strtok֤charΥݥ󥿤ϡ裳Ȥ֤
 * 	ͤɤ߹ʸǤ롥
 * 	ͤ0ΤȤϡ裳ˤNULLǼ롥
 * 	strtokƱɤ꤫³ˤ
 * 	裱NULLꤹ롥
 * 	strtokȰۤʤꡤ裲ˤϥǥߥʸϤ
 * 	strtokϢ³ǥߥ̵뤵뤬
 * 	MyStrtok̵뤻ˡ0֤
 */
extern int MyStrtok(char *s, char delim, char **top);

/*-----
 * IsCommentLineؿ
 * 	ιԤȤιԤȽǤ롥
 * 	ʸϡδؿ̤ȥ/ڡ
 * 	Ȥ롥
 */
extern int IsCommentLine(char *buf);

#endif /* _UTL_TEXT_H_ */
