/* *****************************************************************************
 * ΥեmainؿޤǤ롣
 * 
 *  main
 *    +-my_init					ץβϡϥեΥץ
 *    +-get_GHnum				ѿѿο	
 *    +-Set_data				ϥǡɹ
 *    +-read_STD_results		η̤ɹ
 *    +-allocate_base_matrixes	ܤȤʤޥȥå٥ȥΰ
 *    +-get_GHdata				V+V-dV/dX ͤμ
 *    +-write_S_param			S-system ѥѥ᡼եν񤭽Ф
 *    +-free_base_matrixes		ܤȤʤޥȥå٥ȥΰ賫
 *    +-my_final				ΰγեΥ
 *
 *	S-systemѤParameterե롣
 *
 *	ϥե
 *	result_STD	η̥ե롣
 *	param		᤿Υѥ᡼ե롣
 *
 *	ϥե
 *	s_param		S-systemѤΥѥ᡼ե롣
 *
 * ˡ
 *	Ssystem -Iinput_file -Rresults_STD_file -Ss_param_file [-d]
 *
 *	ǺΤϥᥤؿޤ饤֥ǡ¹ԥ⥸塼Ȥ뤿ˤ
 *	chechdae ǺGHؿ󥯤ɬפ롣
 *
 */

#define _HAVE_MAIN_ROUTINE_

#include "make_s_param.h"

/* եstaticؿΥץȥ */
static int my_init(int argc, char *argv[], char *fname[], int *f_useSTD);
static int allocate_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
		    	double **v_plus, double **v_minus, int n_var, int n_const);
static void free_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
			   	double **v_plus, double **v_minus, int n_var, int n_const);
static int read_STD_results(double *y, int n_var, char **fname);
static int write_S_param(char **fname, double **Gd, double **Gi,
			   	double **Hd, double **Hi, double *v_plus, double *v_minus,
			   	double *y, int n_var, int n_const);
static void my_final(char **fname);

static double g_val=1.0;


/*------------------ main --------------------------------------
 *
 *
 */
int main(int argc, char *argv[])
{
	int i, j, f_useSTD=false;
    char *fname[FILE_NUM];
	double t_start, t_end, h;
	double dt_save, y_tmp[MAX_VAR_NUM];
	int n_var, n_const;
	double *y=NULL, *v_plus=NULL, *v_minus=NULL;
	double **Gd=NULL, **Gi=NULL, **Hd=NULL, **Hi=NULL;

	/* ץβϡϥեΥץ */
	if (my_init(argc, argv, fname, &f_useSTD) < 0) goto err;
	
	/*
	 *	checkdaeǺ桼ؿƤӽФ
	 *	ѿοȸѿο֤Ƥ
	 */
	get_GHnum(&n_var, &n_const);
	
	/*
	 *	᤿ϥե뤫ѥ᡼ɤ߹ࡣ
	 *	ߥ졼ȶ̤ʤΤ y 䥳ȥǡɤ߹ब
	 *	Ǥϰ̵̣
	 */
	if (Set_data(y_tmp, &t_start, &t_end, &h, &dt_save, fname) < 0) goto err;

	if (n_var != Param.n_var || n_const != Param.n_val[1]) {
		log_sys("#  The user function file used for compile and the input file ");
		log_sys("#  used for calculation of STD values are not matched.\n");
		log_sys("#  Number of variables : %d vs %d.\n", n_var, Param.n_var);
		log_sys("#  Number of constant variables : %d vs %d.\n", n_const, Param.n_val[1]);
		goto err;
	}

	y = nr_alloc_vector(1, n_var);
	if (y == NULL) goto err;
	
	if (f_useSTD) {
		/*
	 	*	η̥եɤ߹ y ͤ롣
	 	*	ĤǤˡy Ͱη׻ϥǡ˴ؤʬ򤽤Τޤޤη
	 	*	ϥե˽񤭽Ф
	 	*/
		if (read_STD_results(y, n_var, fname) < 0) goto err;
	} else {
		for (i=1; i<=n_var; i++) y[i] = y_tmp[i];
		log_sys("# !!! Useing initial values as variable(y) data.\n");
	}

	/* ܤȤʤޥȥå٥ȥΰ */
	if (allocate_base_matrixes(&Gd, &Gi, &Hd, &Hi, &v_plus, &v_minus,
						   				n_var, n_const)) goto err;

	for(i=1; i<=n_var; i++ ){
		for( j=1; j<=n_var; j++ ) Gd[i][j] = Hd[i][j] = 0.0;
		for( j=1; j<=n_const; j++ ) Gi[i][j] = Hi[i][j] = 0.0;
	}

	/*
	 *	checkdaeǺ桼ؿƤӽФ
	 *	᤿Υѥ᡼ե뤫ɤ߹ѥ᡼
	 *	Ϥǵ᤿ y ͤȤˡGH¤(ڤӤθ)
	 *	׻֤
	 */
	get_GHdata(Gd, Gi, Hd, Hi, v_plus, v_minus, y, &Param);

	/*
	 *	S-system Υߥ졼ѤΥѥ᡼ե롣
	 *	ŪGdHd׻֤
	 */
	if (write_S_param(fname, Gd, Gi, Hd, Hi, v_plus, v_minus, y, n_var, n_const)) goto err;
		
	/* ܤȤʤޥȥå٥ȥΰ賫 */
	free_base_matrixes(&Gd, &Gi, &Hd, &Hi, &v_plus, &v_minus, n_var, n_const);

	my_final(fname);
	return 0;

err:
	log_sys("\n## ABORT!!\n");

	/* ܤȤʤޥȥå٥ȥΰ賫 */
	free_base_matrixes(&Gd, &Gi, &Hd, &Hi, &v_plus, &v_minus, n_var, n_const);

	my_final(fname);
	return -1;
}

/*---------------------- read_STD_results -------------------------------------
 * Ϥη̤ɹ
 */
static int
read_STD_results(double *y, int n_var, char **fname)
{
	int i, cnt;
	FILE *fp_in;
	double val;
	char *str_tmp=NULL, tline[MAX_LINE];

	if((fp_in = fopen(fname[FILE_STD], "r")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_STD]);
		goto err;
	}

	cnt = 0;
	while(fgets(tline, sizeof tline, fp_in)) {
		if (strncmp(tline, "Solver", 6) == 0) {
			str_tmp = strstr(tline, ":");
			sscanf(str_tmp, ":%d", &i);
			if (i != SOLVER_NO_STD) {
				log_sys("#  This results file is not a STD one. Solver No. %d\n", i);
				goto err;
			}
		}
		if (strncmp(tline, "G-Value", 7) == 0) {	/* G_value add '030729 by Satoh */
			log_sys("== %s\n", tline);
			strsep(&str_tmp, ":");
			g_val = atof(strsep(&str_tmp, ":"));
		}
		if (strncmp(tline, "Param S", 7) == 0) {
			str_tmp = strstr(tline, ":");
			sscanf(str_tmp, ":%d", &i);
			if (i == 1) {
				log_sys("#  This results file performs a parameter survey.\n");
				goto err;
			}
		}
		if (strncmp(tline, "$$", 2) == 0) {
			cnt++;
			if (strstr(tline, "Results") || cnt == 1) break;
			log_sys("#  There is no normal data in this result file.\n");
			goto err;
		}
	}

	while(fgets(tline, sizeof tline, fp_in)) {
		if (strncmp(tline, "$$", 2) == 0) break;
		if (strncmp(tline, "index", 5) == 0) continue;
		if (strlen(tline) < 5) continue;
		sscanf(tline, "%d,%lf", &i, &val);
		if (i < 1 || i > n_var) {
			log_sys("#  Invalid index. : index=%d, number of variables is %d.\n",
						   	i, n_var);
			goto err;
		}
		y[i] = val*g_val;	/* G_value add '030729 by Satoh */
	}

	
	return 0;

err:
	log_sys("## Error in read_STD_results.\n");
	return -1;
}

/*---------------------- write_S_param -------------------------------------
 * ѥ᡼եν񤭽Ф
 */
static int
write_S_param(char **fname, double **Gd, double **Gi, double **Hd, double **Hi,
			   	double *v_plus, double *v_minus, double *y, int n_var, int n_const)
{
	int i, j, cnt_G, cnt_H;
	FILE *fp_out;
	double *alpha=NULL, *beta=NULL;
	double *c_var = Param.val[1];

	if((fp_out = fopen(fname[FILE_SPARAM], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_SPARAM]);
		goto err;
	}

	fprintf(fp_out,"##### Model ################\n");
	fprintf(fp_out,"N_VAR   ;%4d; # num of variables(all)\n", n_var);
	fprintf(fp_out,"N_ALGEBR;%4d; # num of variables(all)\n", 0);

	/* ͤν񤭽Ф */
	fprintf(fp_out,"\n#Y_START ; index; initial_value; tag #comment\n");
	for (i=1; i<=n_var; i++) {
		fprintf(fp_out,"Y_START ;%4d;%12.4e; %s\t#\n", i, y[i]/g_val, getVarTag(i));
		/* G_value add '030729 by Satoh */
	}

	alpha = nr_alloc_vector(1, n_var);
	if (alpha == NULL) goto err_alloc;
	beta = nr_alloc_vector(1, n_var);
	if (beta == NULL) goto err_alloc;
	for (i=1; i<=n_var; i++) {
		alpha[i] = 1.0;
		beta[i]  = 1.0;
	}

	/* G, H, alpha, beta η׻ */
	for (i=1; i<=n_var; i++) {
		for (j=1; j<=n_var; j++) {
			Gd[i][j] = Gd[i][j]*y[j]/v_plus[i];
			Hd[i][j] = Hd[i][j]*y[j]/v_minus[i];
			alpha[i] *= pow(y[j], Gd[i][j]);
			beta [i] *= pow(y[j], Hd[i][j]);
		}
		for (j=1; j<=n_const; j++) {
			Gi[i][j] = Gi[i][j]*c_var[j]/v_plus[i];
			Hi[i][j] = Hi[i][j]*c_var[j]/v_minus[i];
			alpha[i] *= pow(c_var[j], Gi[i][j]);
			beta [i] *= pow(c_var[j], Hi[i][j]);
		}
		alpha[i] = v_plus[i]/alpha[i];
		beta[i]  = v_minus[i]/beta[i];
	}


	/* ѥ᡼ν񤭽Ф */
	fprintf(fp_out,"\n#PARAM;name;index;val;val_start;num_survey;D/R/S;change-val;GA_min;GA_max;tag #comment\n");
	for (i=1; i<=n_const; i++) {
		fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; %s\t#\n",
					   	CONSTANT_PLAYER, i, c_var[i]/g_val, getParamTag(1, i));
	}
	for (i=1; i<=n_var; i++) {
		fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; alpha_%d\t#\n",
					   	"kplus", i, alpha[i], i);
	}
	for (i=1; i<=n_var; i++) {
		fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; beta_%d\t#\n",
					   	"kminus", i, beta[i], i);
	}
	for (i=1, cnt_G=0; i<=n_var; i++) {
		for (j=1; j<=n_var; j++) {
			if (Gd[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; gd_%d_%d\t#\n",
					   	"g", ++cnt_G, Gd[i][j], i, j);
			}
		}
		for (j=1; j<=n_const; j++) {
			if (Gi[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; gi_%d_%d\t#\n",
					   	"g", ++cnt_G, Gi[i][j], i, j);
			}
		}
	}
	for (i=1, cnt_H=0; i<=n_var; i++) {
		for (j=1; j<=n_var; j++) {
			if (Hd[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; hd_%d_%d\t#\n",
					   	"h", ++cnt_H, Hd[i][j], i, j);
			}
		}
		for (j=1; j<=n_const; j++) {
			if (Hi[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; hi_%d_%d\t#\n",
					   	"h", ++cnt_H, Hi[i][j], i, j);
			}
		}
	}

	fprintf(fp_out,"\n#T_EVENT ; name; index; time; value; #comment\n\n");

	fprintf(fp_out,"\n######## Don't edit the following lines. ######\n");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", CONSTANT_PLAYER);
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "kplus");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "kminus");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "g");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "h");

	fclose(fp_out); fp_out = NULL;

	nr_free_vector(alpha, 1, n_var);
	nr_free_vector(beta, 1, n_var);

	return 0;

err_alloc:
	log_sys("#  Cannot allocate memory.\n");

err:
	if (alpha) nr_free_vector(alpha, 1, n_var);
	if (beta) nr_free_vector(beta, 1, n_var);
	if (fp_out != NULL) fclose(fp_out);

	log_sys("## Error in write_S_param.\n");
	return -1;
}

/*---------------- my_init------------------------------------------
 *
 * ץβ
 *
 * I:argc, argv
 * O:y, t_start, t_end, h, dt_save
 *
 */
static int
my_init(int argc, char *argv[], char *fname[], int *f_useSTD)
{
	int i, fcount = 0;
	
#ifdef DBG
	if(log_dbginit(argc, argv)) {
		printf("Cannot open dbgLog file!!");
		goto	err;
	}
#endif

	if(log_sysinit(argc, argv)) {
		printf("Cannot open sysLog file!!");
		goto	err;
	}


#ifdef DBG
	DBGW(10, ("===> my_init enter\n"));
#endif

	for (i = 1; i < argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'I':
				fcount++;
				fname[FILE_IN] = strdup(&argv[i][2]);
				break;
			case 'R':
				fcount++;
				*f_useSTD = true;
				fname[FILE_STD] = strdup(&argv[i][2]);
				break;
			case 'S':
				fcount++;
				fname[FILE_SPARAM] = strdup(&argv[i][2]);
				break;
			case 'd':
				break;
			default:
				log_sys("#  Invalid argument !!\n");
				log_sys("#  Usage : Module -IFile_input [-RFile_STD] -OFile_out -SFile_Sparam\n");
				goto	err;
			}
		}
	}
	if (*f_useSTD == false) fname[FILE_STD] = strdup("DUMMY");
	if (fcount < FILE_NUM-1 || fcount > FILE_NUM) {
		log_sys("#  This program needs %d(or %d) input files. But now it has %d file(s).\n",
					   FILE_NUM, FILE_NUM-1, fcount);
		log_sys("#  Usage : Module -IFile_input [-RFile_STD] -OFile_out -SFile_Sparam\n");
		goto err;
	}

	return 0;

err:;
	log_sys("## Error in my_init.\n");
	exit(-1);
}

/*---------------------- my_final -------------------------------------
 *	λ
 */
static void my_final(char **fname)
{
	int i;
		
	/*
	 * ѥ᡼γǼΰγ
	 */
	freeParamTag();

	/*
	 * ե̾γǼΰγ
	 */
	for (i=0; i<FILE_NUM; i++) free((void *) fname[i]);

	/*
	 * λ
	 */
	log_sysfinalize();
	log_dbgfinalize();
}

/*---------------------- allocate_base_matrixes -------------------------------------
 *	ܥޥȥåΰ
 */
static int
allocate_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
			    	double **v_plus, double **v_minus, int n_var, int n_const)
{
	*v_plus = nr_alloc_vector(1, n_var);
	if (*v_plus == NULL) goto err_alloc;
	*v_minus = nr_alloc_vector(1, n_var);
	if (*v_minus == NULL) goto err_alloc;
	*Gd = nr_alloc_matrix(1, n_var, 1, n_var);
	if (*Gd == NULL) goto err_alloc;
	*Gi = nr_alloc_matrix(1, n_var, 1, n_const);
	if (*Gi == NULL) goto err_alloc;
	*Hd = nr_alloc_matrix(1, n_var, 1, n_var);
	if (*Hd == NULL) goto err_alloc;
	*Hi = nr_alloc_matrix(1, n_var, 1, n_const);
	if (*Hi == NULL) goto err_alloc;

	return 0;

err_alloc:
	log_sys("## Error in allocate_base_matrixes.\n");
	return -1;
}

/*---------------------- free_base_matrixes -------------------------------------
 *	ܥޥȥåΰ賫
 */
static void
free_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
			    	double **v_plus, double **v_minus, int n_var, int n_const)
{
	if (*v_plus) nr_free_vector(*v_plus, 1, n_var);
	if (*v_minus) nr_free_vector(*v_minus, 1, n_var);
	if (*Gd) nr_free_matrix(*Gd, 1, n_var, 1, n_var);
	if (*Gi) nr_free_matrix(*Gi, 1, n_var, 1, n_const);
	if (*Hd) nr_free_matrix(*Hd, 1, n_var, 1, n_var);
	if (*Hi) nr_free_matrix(*Hi, 1, n_var, 1, n_const);
}

#undef _HAVE_MAIN_ROUTINE_
