#include <math.h>

#include "usrFunc.h"

#define PI 	3.141592653589793

int UsrFitness(const double *x, int num_variable, int argc, char **argv, double *fitness){
	/* Rastrigin */
	int 	i;
	double	d = 0;

	for(i = 0; i < num_variable; i++){
		d += x[i] * x[i] - 10 * cos(2 * PI * x[i]);
	}

	*fitness = -(10 * num_variable + d);

	return 0;
}
		
	

