/**************************************************************
 *	TMCƖxVXei߂QPj
 *
 *		XXXXXXXXXXXXXXXX
 *
 *	Copyright (C) 2000 %%MAKER%%
 **************************************************************/
#ifndef lint
static char SccsId[] = "%Z%META21 %M% %I% %D% %U%";
#endif

#ifndef DEBUG
#define DEBUG
#endif
#include "ju_conv.h"
#include "c_dbg.h"
#include "errno.h"
#include "signal.h"
#include "sys/wait.h"


/* C̍\̂oCiC[WŎwt@C|C^write */
static int
ju_write_struct(FILE *fp, MM_DATA_t *mmd, void *recv)
{
	char		*rec = (char*)recv;
        int		i, j;
        M_DATA_t	*md = mmd->mdata;
        MM_DATA_t	*a_mmd;
        M_DATA_t	*a_md;
        long long	a_num;
        char		*a_rec;
	int		r;
        
        for (i=0; i<mmd->fld_n; i++) {
                switch (md[i].type) {
                case M_STR:
                case M_BYTE:
                case M_SHRT:
                case M_INT:
                case M_LONG:
                case M_BOOL:
			r = fwrite( rec + md[i].offset, md[i].len, 1, fp );
			if( r == 0 || ferror(fp) )
				goto err;
                        break;
                case M_BOOLARRY:
                case M_BARRY:
                case M_SARRY:
                case M_IARRY:
                case M_LARRY:
			r = fwrite( rec + md[i].offset, md[i].len, md[i].arry_n, fp );
			if( r == 0 || ferror(fp) )
				goto err;
                        break;
                case M_ARRY:
                        if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
                                LOG_ERR(("Unknown array class %s\n", md[i].arryclsname));
                                goto err;
                        }
                        if (JU_fldname2md(mmd, md[i].arrynumname, &a_md)) {
                                LOG_ERR(("Unknown array count field %s\n", md[i].arrynumname));
                                goto err;
                        }
                        if (JU_getnum(rec, a_md->offset, a_md->len, &a_num)) {
                                LOG_ERR(("Get a_num err\n"));
                                goto err;
                        }
                        r = fwrite( &a_num, sizeof(a_num), 1, fp );
			if( r == 0 || ferror(fp) )
				goto err;
                        for (j=0; j<a_num; j++) {
                                a_rec = *((char**)(rec+md[i].offset));
                                if (ju_write_struct(fp, a_mmd, a_rec+(a_mmd->struct_size*j))) {
                                        goto err;
                                }
                        }
                        break;
		case M_SUBSTRCT:
                        if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
                                LOG_ERR(("Unknown substruct class %s\n", md[i].arryclsname));
                                goto err;
                        }
			a_rec = rec+md[i].offset;
			if (ju_write_struct(fp, a_mmd, a_rec)) {
				goto err;
			}
                        break;
                default:
                        break;
                }
        }
	if( fflush(fp) == EOF )
		goto err;

        return 0;
err:
        return -1;
}

/* wt@C|C^f[^readC\̍쐬 */
static int
ju_read_struct(FILE *fp, MM_DATA_t *mmd, void *recv)
{
	char		*rec = (char*)recv;
        int		i, j;
        M_DATA_t	*md = mmd->mdata;
        MM_DATA_t	*a_mmd;
        M_DATA_t	*a_md;
        long long	a_num;
        char		*a_rec;
	int		r;

        for (i=0; i<mmd->fld_n; i++) {
                switch (md[i].type) {
                case M_STR:
                case M_BYTE:
                case M_SHRT:
                case M_INT:
                case M_LONG:
                case M_BOOL:
			r = fread( rec + md[i].offset, md[i].len, 1, fp );
			if( r == 0 || ferror(fp) )
				goto err;
                        break;
                case M_BOOLARRY:
                case M_BARRY:
                case M_SARRY:
                case M_IARRY:
                case M_LARRY:
			r = fread( rec + md[i].offset, md[i].len, md[i].arry_n, fp );
			if( r == 0 || ferror(fp) )
				goto err;
                        break;
                case M_ARRY:
		        {
			char	*req = NULL;

                        if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
                                LOG_ERR(("Unknown array class %s\n", md[i].arryclsname));
                                goto err;
                        }
                        r = fread( &a_num, sizeof(a_num), 1, fp );
			if( r == 0 || ferror(fp) )
				goto err;
			if( a_num >= 0LL ){
				req = (char *)calloc( a_mmd->struct_size, a_num );
				if (!req) {
					LOG_ERR(("structure malloc fail\n"));
					goto err;
				}
			}
                        for (j=0; j<a_num; j++) {
                                if( ju_read_struct( fp, a_mmd,
						    req + (a_mmd->struct_size * j) ) ){
                                        goto err;
                                }
                        }
			memcpy( rec + md[i].offset, &req, md[i].len );
			}
                        break;
		case M_SUBSTRCT:
                        if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
                                LOG_ERR(("Unknown substruct class %s\n", md[i].arryclsname));
                                goto err;
                        }
			a_rec = rec+md[i].offset;
			if (ju_read_struct(fp, a_mmd, a_rec)) {
				goto err;
			}
                        break;
                default:
                        break;
                }
        }
        return 0;
err:
        return -1;
}

/*****************************************************************************
 * ֐
 *      JU_exec_ap
 * @\
 *      wAPNďI҂
 * ֐l
 *      ==0:     
 *      !=0:     ُ
 * 
 *	evZXŃR[
 *      
 *****************************************************************************/
int
JU_exec_ap(
	char		*apname,	/* I : NAP */
	MM_DATA_t	*req_mmd,	/* I : RequestMMf[^ */
	void		*req,		/* I : Requestf[^ */
	MM_DATA_t	*rsp_mmd,	/* I : ResponseMMf[^ */
	void		*rsp		/* O : Responsef[^ */
	)
{
	char			*funcname = "JU_exec_ap";
	int			p2c_fds[2];	/* eqpCv */
	int			c2p_fds[2];	/* qepCv */
	FILE			*rfp = NULL, *wfp = NULL;
	int			stat_loc = 0, w = 0, rc = -1;
	pid_t			pid;
	struct sigaction	cbuf, ibuf, qbuf, pbuf, ignore, dfl;
	sigset_t		mask;
	sigset_t		savemask;
	int			forked = 0;
	int			sigchld_changed = 0, sigpipe_changed = 0;
	int			sigquit_changed = 0, sigint_changed = 0;

	/* `FbN */
	if( !apname || apname[0] == '\0' || !req_mmd || !req ||
	    !rsp_mmd || !rsp ){
		LOG_ERR(("%s: invalid args\n", funcname));
		return -1;
	}

	/*  */
	p2c_fds[0] = p2c_fds[1] = -1;
	c2p_fds[0] = c2p_fds[1] = -1;

	/* e<->qԒʐMppCv쐬 */
	if( pipe(p2c_fds) != 0 ){
		LOG_ERR(("%s: pipe fail\n", funcname));
		goto err;
	}
	if( pipe(c2p_fds) != 0 ){
		LOG_ERR(("%s: pipe fail\n", funcname));
		goto err;
	}

	/* SIGCHLDnh̐ݒƁÃVOinhZbg̃Z[u */
	(void)sigemptyset( &mask );
	(void)sigaddset( &mask, SIGCHLD );
	(void)sigprocmask( SIG_BLOCK, &mask, &savemask );
	(void)memset( &dfl, 0, sizeof(dfl) );
	dfl.sa_handler = SIG_DFL;
	(void)sigaction( SIGCHLD, &dfl, &cbuf );
	sigchld_changed++;

	/* vZXN */
	if( (pid=fork()) == 0 ){
		/*
		 * qvZX
		 */
		(void)sigprocmask( SIG_SETMASK, &savemask, NULL );

		/* W͂p2cpCv */
		(void)close( p2c_fds[1] );
		(void)close( 0 );
		(void)dup2( p2c_fds[0], 0 );
		(void)close( p2c_fds[0] );

		/* Wo͂c2ppCv */
		(void)close( c2p_fds[0] );
		(void)close( 1 );
		(void)dup2( c2p_fds[1], 1 );
		(void)close( c2p_fds[1] );

		/* N */
		execlp( apname, apname, (char *)0 );
		/* Ns */
		_exit(127);
	}
	else if( pid < 0 ){
		/*
		 * evZXFforkG[
		 */
		LOG_ERR(("%s: fork fail\n", funcname));
		goto err;
	}

	/*
	 * evZXij
	 */
	forked++;

	/* SIGINT,SIGQUIT,SIGPIPE𖳎 */
	(void)memset( &ignore, 0, sizeof(ignore) );
	ignore.sa_handler = SIG_IGN;
	(void)sigaction( SIGINT, &ignore, &ibuf );  sigint_changed++;
	(void)sigaction( SIGQUIT, &ignore, &qbuf ); sigquit_changed++;
	(void)sigaction( SIGPIPE, &ignore, &pbuf ); sigpipe_changed++;

	/* e->qւ̃nhZbg */
	(void)close(p2c_fds[0]); p2c_fds[0] = -1;
	if( (wfp=fdopen( p2c_fds[1], "wb" )) == NULL ){
		LOG_ERR(("%s: fdopen fail\n", funcname));
		goto err;
	}

	/* e<-qւ̃nhZbg */
	(void)close(c2p_fds[1]); c2p_fds[1] = -1;
	if( (rfp=fdopen( c2p_fds[0], "rb" )) == NULL ){
		LOG_ERR(("%s: fdopen fail\n", funcname));
		goto err;
	}

	/* f[^n */
	if( ju_write_struct( wfp, req_mmd, req ) ){
		LOG_ERR(("%s: ju_write_struct fail\n", funcname));
		goto err;
	}

	/* ʂǂ(܂ő҂) */
	if( ju_read_struct( rfp, rsp_mmd, rsp ) ){
		LOG_ERR(("%s: ju_read_struct fail\n", funcname));
		goto err;
	}

	/* ܂ŐȂUrcNA */
	rc = 0;

err:
        /* Kv΁AqvZX̏I҂ */
	if( forked ){
            do {
#if !defined(TARGET_LINUX) && !defined(_HPUX)
                w = waitpid( pid, &stat_loc, _WNOCHLD );
#else
                w = waitpid( pid, &stat_loc, 0 );
#endif
            } while( w == -1 && errno == EINTR );
	}

	/* t@Cnh̃N[Y */
	if( wfp ){
		(void)fclose(wfp); p2c_fds[1] = -1;
	}
	if( rfp ){
		(void)fclose(rfp); c2p_fds[0] = -1;
	}

        /* VOinh̃XgA */
	if( sigpipe_changed )
        	(void)sigaction( SIGPIPE, &pbuf, NULL );
	if( sigint_changed )
        	(void)sigaction( SIGINT, &ibuf, NULL );
	if( sigquit_changed )
	        (void)sigaction( SIGQUIT, &qbuf, NULL );
	if( sigchld_changed )
	        (void)sigaction( SIGCHLD, &cbuf, NULL );
        (void)sigprocmask( SIG_SETMASK, &savemask, NULL );

	/* pCṽN[Y */
	if( c2p_fds[0] != -1 )
		(void)close( c2p_fds[0] );
	if( c2p_fds[1] != -1 )
		(void)close( c2p_fds[1] );
	if( p2c_fds[0] != -1 )
		(void)close( p2c_fds[0] );
	if( p2c_fds[1] != -1 )
		(void)close( p2c_fds[1] );

	/*
	 * qvZX̌ʎMĂ΁Aexit status
	 * sƂ
	 */
	if( rc == 0 ){
        	/** rc = ( (w == -1) ? w : stat_loc ); **/
		if( w == -1 )
			rc = w;
	}
        return rc;
}

/*****************************************************************************
 * ֐
 *      JU_get_request
 * @\
 *      w\̖̃GAmۂAevZX瑗ꂽlZbg
 * ֐l
 *      ==0:     
 *      !=0:     ُ
 * 
 *	EqvZXŃR[
 *	EreqGÁAsvɂȂJU_free_request()邱
 *      
 *****************************************************************************/
int
JU_get_request(
	char	*strname,	/* I: NGXg\̖ */
	void	**req		/* O: NGXg\ */
	)
{
	char		*funcname = "JU_get_request";
	MM_DATA_t	*req_mmd;

	/* `FbN */
	if( !strname || strname[0] == '\0' || !req ){
                LOG_ERR(("%s: invalid args\n", funcname));
		return -1;
	}

	/*  */
	*req = NULL;

        /* MMf[^擾 */
        if (JU_strname2mmd(strname, &req_mmd)) {
                LOG_ERR(("%s: no mmd()\n", funcname));
                goto err;
        }

	/* NGXg\̗̈mۂ */
        *req = (void*)calloc( req_mmd->struct_size, 1 );
	if( *req == NULL ){
		LOG_ERR(("%s: cannot allocate memory\n", funcname));
		goto err;
	}

        /* NGXgf[^ǂݍ */
        if( ju_read_struct( stdin, req_mmd, req ) ){
		LOG_ERR(("%s: ju_read_struct error\n", funcname));
		goto err;
	}

	return 0;
err:
	if( *req ){
		free( *req ); *req = NULL;
	}
	return -1;
}

/*****************************************************************************
 * ֐
 *      JU_free_request
 * @\
 *      JU_get_requestœIɊmۂꂽrequesẗ̉
 * 
 *	EqvZXŃR[
 *****************************************************************************/
void
JU_free_request(
	char	*strname,	/* I: NGXg\̖ */
	void	*req		/* I: NGXg\ */
	)
{
	char		*funcname = "JU_free_request";
	MM_DATA_t	*req_mmd;

	/* `FbN */
	if( !strname || strname[0] == '\0' || !req ){
		return;
	}
        /* MMf[^擾 */
        if (JU_strname2mmd(strname, &req_mmd)) {
                LOG_ERR(("%s: no mmd()\n", funcname));
                return;
        }
	/*  */
	(void)JU_free( req_mmd, req );
}

/*****************************************************************************
 * ֐
 *      JU_put_response
 * @\
 *      evZXɏʂԋp
 * ֐l
 *      ==0:     
 *      !=0:     ُ
 * 
 *	EqvZXŃR[
 *****************************************************************************/
int
JU_put_response(
	char	*strname,	/* I: \̖ */
	void	*rsp		/* I: X|XGA */
	)
{
	char		*funcname = "JU_put_response";
	MM_DATA_t	*rsp_mmd;

	/* `FbN */
	if( !strname || strname[0] == '\0' || !rsp ){
                LOG_ERR(("%s: invalid args\n", funcname));
		return -1;
	}

        /* MMf[^擾 */
        if (JU_strname2mmd(strname, &rsp_mmd)) {
                LOG_ERR(("%s: no mmd()\n", funcname));
                goto err;
        }

        /* ʂo */
        if( ju_write_struct( stdout, rsp_mmd, rsp ) ){
                LOG_ERR(("%s: ju_write_struct error\n", funcname));
		goto err;
	}
	return 0;
err:
	return -1;
}
