/**
 * ѥ᡼եƤޡ롣
 *
 *     mergeParams -Iե -Rե [-B]
 *
 *   եƤΤե˳ܤΤͤ
 *   ե˥ޡ롣
 *
 *   ץ:
 *   -I    եΥե̾ѡ
 *   -R    եΥե̾ѡ
 *   -B    Υץ󤬻ꤵ줿Ȥեˤ
 *         ̤ͤιܤΤߤˤĤƥޡԤ
 *         (̤ʤо˶ޡ)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "logUtil.h"

#define BUFFSIZE	65536
#define MAX_PARAMS_NUM	1024
#define TRUE		-1
#define FALSE		0

typedef struct {
	char *all;		/* Ԥޤ뤴 */
	char *key;		/*  (Y_START or PARAM or ...) */
	char *key_stripped;	/*  (Ѥ) */
	char *name;		/* name */
	char *index;		/* index */
	char *value;		/* initial_value ޤ val */
	char *val_start;	/* val_start */
	char *num_survey;	/* num_survey */
	char *DR;		/* D/R */
	char *change_val;	/* change-val */
	char *GA_start;		/* GA_start */
	char *GA_end;		/* GA_end */
	char *tag;		/* tag */
	char *tag_stripped;	/* tag (Ѥ) */
	char *comment;		/*  */
} Param_set;

/**
 * NULL б strdup
 * Ϥ NULL ʤ NULL 򡢤Ǥʤ strdup ̤֤
 *
 * @param s ʸ
 * @return ʸʣ free()
 */
static char* strdup2 (char *s) {
	char		*ret = NULL;

	if (s)
		ret = strdup (s);

	return ret;
}

/**
 * ʸζ롣
 * ͤϿ˥ݤ֤ᤢȤ free 뤳ȡ
 * Ϥ NULL ξ NULL ֤
 *
 * @param s ʸ
 * @return ʸ󤫤ζΡ
 */
static char* strip (char *s) {
	int		length;
	char		*t, *ret;

	/* Ϥ NULL ξ NULL ֤ */
	if (s == NULL)
		return NULL;

	t = (char*) calloc (strlen (s) + 1, sizeof(char));
	ret = t;

	/* ¦ζФ */
	while (*s == ' ' || *s == '\t' || *s == '\r' || *s == '\n')
		s++;

	/* ԡƥԡΥݥ󥿤˰ư */
	length = strlen (s);
	memcpy (t, s, length);
	t += length - 1;

	/* ¦ζ \0  */
	while (*t == ' ' || *t == '\t' || *t == '\r' || *t == '\n') {
		*t = '\0';
		t--;
	}

	return ret;
}

/**
 *
 */
int check_duplication (Param_set **params, int param_n) {
	int		i, j;
	char		*key;

#ifdef DBG
	printf ("check_duplication() start.\n");
#endif

	for (i = 0; i < param_n-1; i++) {
		key = params[i]->key_stripped;
		if (strcmp (key, "Y_START") != 0 && strcmp (key, "PARAM") != 0)
			continue;
		for (j = i+1; j < param_n; j++) {
			key = params[j]->key_stripped;
			if (strcmp (key, "Y_START") != 0 && strcmp (key, "PARAM") != 0)
				continue;
			if (strcmp (params[i]->tag_stripped,
				    params[j]->tag_stripped) == 0) {
				log_sys ("tag dupplication:\n\t%s\n\t%s\n", params[i]->all, params[j]->all);
				goto err;
			}
		}
	}

#ifdef DBG
	printf ("check_duplication() end.\n");
#endif

	return 0;
  err:
	return -1;
}

/**
 * եɤ߹ߥѥ᡼åȹ¤Τ˥ȥ롣
 *
 * @param fp I: ɤ߹եΥեݥ󥿡
 *              ɤ߹Ѥ˳Ƥɬפ롣
 * @param params O: ѥ᡼åȹ¤ΤؤΥݥ󥿡
 * @param param_n O: ȥѥ᡼åȤο
 * @return ｪλʤ 0 ۾ʤ -1
 */
static int read_params (FILE *fp, Param_set **params, int *param_n) {
	char		line[BUFFSIZE];
	char		*buff = NULL;
	char		*buff_orig;
	char		*s = NULL;
	char		*t = NULL;
	char		*tag_and_comment = NULL;
	int		isMerge;

#ifdef DBG
	printf ("read_params() start.\n");
#endif

	*param_n = 0;
	while (fgets (line, BUFFSIZE, fp)) {
		buff = strdup (line);
		buff_orig = buff;
		s = strsep (&buff, ";");
		t = strip (s);

		params[*param_n] = (Param_set*) calloc (1, sizeof(Param_set));
		params[*param_n]->all = strdup (line);
		params[*param_n]->key = strdup (s);
		params[*param_n]->key_stripped = t;

		if (strcmp (t, "Y_START") == 0) {
			isMerge = TRUE;
			s = strsep (&buff, ";");
			params[*param_n]->index = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->value = strdup2 (s);
			s = strsep (&buff, ";");
			tag_and_comment = strdup2 (s);
			s = strsep (&buff, ";"); /* 顼å */
		} else if (strcmp (t, "PARAM") == 0) {
			isMerge = TRUE;
			s = strsep (&buff, ";");
			params[*param_n]->name = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->index = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->value = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->val_start = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->num_survey = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->DR = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->change_val = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->GA_start = strdup2 (s);
			s = strsep (&buff, ";");
			params[*param_n]->GA_end = strdup2 (s);
			s = strsep (&buff, ";");
			tag_and_comment = strdup2 (s);
			s = strsep (&buff, ";"); /* 顼å */
		} else {
			isMerge = FALSE;
		}

		free (buff_orig);

		if (isMerge) {
			/* ѥ졼­ʤ椫 strsep η̤ NULL ˤʤ  Ǹ tag_and_comment  NULL ˤʤ */
			if (tag_and_comment == NULL) {
				log_sys ("Too few separators in line:\n\t%s\n", line);
				goto err;
			}

			/* ѥ졼¿кǸ strsep  NULL  */
			if (s != NULL) {
				log_sys ("Too many separators in line:\n\t%s\n", line);
				goto err;
			}

			/* tag_and_comment  tag, tag_stripped, comment */
			buff = strdup (tag_and_comment);
			buff_orig = buff;
			s = strsep (&buff, "#");
			params[*param_n]->tag = strdup2 (s);
			params[*param_n]->tag_stripped = strip (s);
			params[*param_n]->comment = strdup2 (buff);
			free (buff_orig);
		}

		(*param_n)++;

		if (*param_n >= MAX_PARAMS_NUM) {
			log_sys ("Too many parameters.\n");
			goto err;
		}
	}

#ifdef DBG
	printf ("read_params() end.\n");
#endif

	return 0;
  err:
	return -1;
}

/**
 * ե򳫤 read_params() ꤲ롣
 *
 * read_params() ǤϥեƤɤ߹ߥѥ᡼åȹ¤Τ˥ȥ롣
 *
 * @param fname_r I: եΥե̾
 * @param fname_i I: եΥե̾
 * @param param_old O: ե뤫ɤ߹ѥ᡼򥹥ȥѥ᡼åȹ¤ηؤΥݥ
 * @param param_new O: ե뤫ɤ߹ѥ᡼򥹥ȥѥ᡼åȹ¤ηؤΥݥ
 * @param p_old_n O: ե뤫ɤ߹ѥ᡼åȤο
 * @param p_new_n O: ե뤫ɤ߹ѥ᡼åȤο
 * @return ｪλʤ 0 ۾ʤ -1
 */
int import_files (char *fname_r, char *fname_i, Param_set **param_old, Param_set **param_new, int *p_old_n, int *p_new_n) {
	FILE		*fp;

#ifdef DBG
	printf ("import_files() start.\n");
#endif

	if ((fp = fopen (fname_r, "r")) == NULL){
		log_sys ("Can't open %s for reading.\n", fname_r);
		goto err;
	}
	if (read_params (fp, param_old, p_old_n) < 0) {
		log_sys ("Can't read parameters. (file = %s)\n", fname_r);
		goto err;
	}
	fclose (fp);

	if ((fp = fopen (fname_i, "r")) == NULL){
		log_sys ("Can't open %s for reading.\n", fname_i);
		goto err;
	}
	if (read_params (fp, param_new, p_new_n) < 0) {
		log_sys ("Can't read parameters. (file = %s)\n", fname_i);
		goto err;
	}
	fclose (fp);

#ifdef DBG
	printf ("import_files() end.\n");
#endif

	return 0;

  err:
	return -1;

}

/**
 * ѥ᡼ޡ롣
 *
 * @param param_old I: ե뤫ɤ߹ѥ᡼
 * @param param_new IO: ե뤫ɤ߹ѥ᡼
 * @param p_old_n I: ե뤫ɤ߹ѥ᡼ο
 * @param p_new_n I: ե뤫ɤ߹ѥ᡼ο
 * @param overwrite_non_blank_param I: ͤǤʤѥ᡼񤭤ʤ 1 ʤʤ 0
 * @return ｪλʤ 0 ۾ʤ -1
 */
int merge_params (Param_set **param_old, Param_set **param_new, int *p_old_n, int *p_new_n, int overwrite_non_blank_param) {
	int		i, j, vlen;
	int		is_y_start, is_param;
	char		buff[BUFFSIZE];
//	char		*key, *name, *tag, *value;
	char		*key, *tag, *value;
	double		d_value;

#ifdef DBG
	printf ("merge_params() start.\n");
#endif

	for (i=0; i<*p_new_n; i++) {
		key = param_new[i]->key_stripped;
		is_y_start = strcmp (key, "Y_START");
		is_param = strcmp (key, "PARAM");
		if (is_y_start != 0 && is_param != 0)
			continue;
		tag = param_new[i]->tag_stripped;
		value = strip (param_new[i]->value);
		vlen = strlen (value);
		free (value);
		if (overwrite_non_blank_param == 0 && vlen > 0)
			continue;
		for (j=0; j<*p_old_n; j++) {
			if (is_y_start == 0) {
				if (strcmp (param_old[j]->key_stripped, key) == 0 &&
				    strcmp (param_old[j]->tag_stripped, tag) == 0
					) {
					sscanf (param_old[j]->value, "%lE", &d_value);
					if (param_new[i]->comment) {
						snprintf (buff, BUFFSIZE, "%s;%s;%12.4e;%s#%s", param_new[i]->key, param_new[i]->index, d_value, param_new[i]->tag, param_new[i]->comment);
					} else {
						snprintf (buff, BUFFSIZE, "%s;%s;%12.4e;%s", param_new[i]->key, param_new[i]->index, d_value, param_new[i]->tag);
					}
					free (param_new[i]->all);
					param_new[i]->all = strdup (buff);
					break;
				}
			} else if (is_param == 0) {
				if (strcmp (param_old[j]->key_stripped, key) == 0 &&
				    strcmp (param_old[j]->tag_stripped, tag) == 0
					) {
					sscanf (param_old[j]->value, "%lE", &d_value);
					if (param_new[i]->comment) {
						snprintf (buff, BUFFSIZE, "%s;%s;%s;%12.4g;%s;%s;%s;%s;%s;%s;%s#%s", param_new[i]->key, param_new[i]->name, param_new[i]->index, d_value, param_new[i]->val_start, param_new[i]->num_survey, param_new[i]->DR, param_new[i]->change_val, param_new[i]->GA_start, param_new[i]->GA_end, param_new[i]->tag, param_new[i]->comment);
					} else {
						snprintf (buff, BUFFSIZE, "%s;%s;%s;%12.4g;%s;%s;%s;%s;%s;%s;%s", param_new[i]->key, param_new[i]->name, param_new[i]->index, d_value, param_new[i]->val_start, param_new[i]->num_survey, param_new[i]->DR, param_new[i]->change_val, param_new[i]->GA_start, param_new[i]->GA_end, param_new[i]->tag);
					}
					free (param_new[i]->all);
					param_new[i]->all = strdup (buff);
					break;
				}
			}
		}
	}

#ifdef DBG
	printf ("merge_params() end.\n");
#endif

	return 0;
}

/**
 * ޡѥ᡼ե˽Ϥ롣
 *
 * @param fname_i I: եΥե̾
 * @param param_new I: Ϥޡѥѥ᡼
 * @param p_new_n I: Ϥޡѥѥ᡼ο
 * @return ｪλʤ 0 ۾ʤ -1
 */
int export_params(char *fname_i, Param_set *param_new[], int *p_new_n) {
	int		i;
	FILE		*fp;

#ifdef DBG
	printf ("export_params() start.\n");
#endif

	if ((fp = fopen (fname_i, "w")) == NULL){
		log_sys ("Can't open %s for writing\n", fname_i);
		goto err;
	}
	
	for (i=0; i<*p_new_n; i++) {
		fputs ((*param_new[i]).all, fp);
	}

	fclose (fp);

#ifdef DBG
	printf ("export_params() end.\n");
#endif

	return 0;

  err:
	return -1;
}

/**
 * mergeParams -- ᥤ
 */
int main (int argc, char *argv[]) {
	int		i;
	int		overwrite_non_blank_param = 1;
	char		fname_i[FILENAME_MAX];
	char		fname_r[FILENAME_MAX];
	Param_set	**param_old = NULL;
	Param_set	**param_new = NULL;
	int		p_old_n = 0;
	int		p_new_n = 0;

#ifdef DBG
	printf ("main() start.\n");
#endif

	param_old = (Param_set **)calloc (MAX_PARAMS_NUM, sizeof(Param_set*));
	param_new = (Param_set **)calloc (MAX_PARAMS_NUM, sizeof(Param_set*));

#ifdef DBG
	// open debug-log file.
	if (log_dbginit (argc, argv)) {
		printf ("Can't open dbgLog file!!");
		goto err;
	}
#endif

	// open sys-log file.

	if (log_sysinit (argc, argv)) {
		printf ("Can't open sysLog file!!");
		goto err;
	}

	// ץβ
	memset (fname_i, 0, sizeof (fname_i));
	memset (fname_r, 0, sizeof (fname_r));
	for (i=0; i<argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'I':
				strncpy (fname_i, &argv[i][2], sizeof (fname_i));
				break;
			case 'R':
				strncpy (fname_r, &argv[i][2], sizeof (fname_r));
				break;
			case 'B':
				overwrite_non_blank_param = 0;
				break;
			default:
				log_sys ("Invalid argument !!\n");
				goto err;
			}
		}
	}
	if (fname_i[0] == '\0' || fname_r[0] == '\0') {
		log_sys ("Too few arguments !!\n");
		goto err;
	}

	// ե򳫤Ÿ
	if (import_files (fname_r, fname_i, param_old, param_new, &p_old_n, &p_new_n) < 0) {
		log_sys ("Can't import files !!\n");
		goto err;
	}

	/* Ʊ쥿ĥѥ᡼ 1 եʣä饨顼 */
	if (check_duplication (param_old, p_old_n) ||
	    check_duplication (param_new, p_new_n)) {
		log_sys ("Error !! : tag duplication.\n");
		goto err;
	}

	// Ÿѥ᡼åȤޡ
	if (merge_params (param_old, param_new, &p_old_n, &p_new_n, overwrite_non_blank_param) < 0) {
		log_sys ("Can't merge parameters !!\n");
		goto err;
	}

	// ޡѥ᡼åȤե˽񤭽Ф
	if (export_params (fname_i, param_new, &p_new_n) < 0) {
		log_sys ("Can't export parameters !!\n");
		goto err;
	}

	// 
	if (param_old) {
		for (i=0; i<p_old_n; i++) {
			if (param_old[i]) {
				free (param_old[i]->all);
				free (param_old[i]->key);
				free (param_old[i]->key_stripped);
				free (param_old[i]->name);
				free (param_old[i]->index);
				free (param_old[i]->value);
				free (param_old[i]->val_start);
				free (param_old[i]->num_survey);
				free (param_old[i]->DR);
				free (param_old[i]->change_val);
				free (param_old[i]->GA_start);
				free (param_old[i]->GA_end);
				free (param_old[i]->tag);
				free (param_old[i]->tag_stripped);
				free (param_old[i]);
			}
		}
		free (param_old);
	}
	if (param_new) {
		for (i=0; i<p_new_n; i++) {
			if (param_new[i]) {
				free (param_new[i]->all);
				free (param_new[i]->key);
				free (param_new[i]->key_stripped);
				free (param_new[i]->name);
				free (param_new[i]->index);
				free (param_new[i]->value);
				free (param_new[i]->val_start);
				free (param_new[i]->num_survey);
				free (param_new[i]->DR);
				free (param_new[i]->change_val);
				free (param_new[i]->GA_start);
				free (param_new[i]->GA_end);
				free (param_new[i]->tag);
				free (param_new[i]->tag_stripped);
				free (param_new[i]->comment);
				free (param_new[i]);
			}
		}
		free (param_new);
	}

#ifdef DBG
	printf ("main() end.\n");
#endif

	return 0;

  err:
	if (param_old) {
		for (i=0; i<p_old_n; i++) {
			if (param_old[i]) {
				free (param_old[i]->all);
				free (param_old[i]->key);
				free (param_old[i]->key_stripped);
				free (param_old[i]->name);
				free (param_old[i]->index);
				free (param_old[i]->value);
				free (param_old[i]->val_start);
				free (param_old[i]->num_survey);
				free (param_old[i]->DR);
				free (param_old[i]->change_val);
				free (param_old[i]->GA_start);
				free (param_old[i]->GA_end);
				free (param_old[i]->tag);
				free (param_old[i]->tag_stripped);
				free (param_old[i]->comment);
				free (param_old[i]);
			}
		}
		free (param_old);
	}
	if (param_new) {
		for (i=0; i<p_new_n; i++) {
			if (param_new[i]) {
				free (param_new[i]->all);
				free (param_new[i]->key);
				free (param_new[i]->key_stripped);
				free (param_new[i]->name);
				free (param_new[i]->index);
				free (param_new[i]->value);
				free (param_new[i]->val_start);
				free (param_new[i]->num_survey);
				free (param_new[i]->DR);
				free (param_new[i]->change_val);
				free (param_new[i]->GA_start);
				free (param_new[i]->GA_end);
				free (param_new[i]->tag);
				free (param_new[i]->tag_stripped);
				free (param_new[i]->comment);
				free (param_new[i]);
			}
		}
		free (param_new);
	}

	return -1;

}
